#ifndef GENRES_H_
#define GENRES_H_

/****
History
14/06/28	fixed genresControlKey_t.ID
14/06/27	fixed genresAnim_t.nbTiles
			added some comments
			added genresControlxxx
xx/xx/xx	initial version
*****/


//TILES
struct genresTiles
{
	u16 *pal; 		//pointer to pal data
	u32 *tiles;		//pointer to tiles data
	u16 width;		//width in tiles
	u16 height;		//height in tiles
	u16 compressedSize; //0 in this demo, more coming soon
};
typedef struct genresTiles genresTiles_t;

//SPRITES
struct genresSprites
{
	u16 *pal; 		//pointer to pal data
	u32 **sprites;		//pointer to sprites data
	u16 count;		//nb sprites
	u16 width;		//width of each sprite in pixels
	u16 height;		//height of each sprite in pixels
	u16 size; 		//since we use width/height in pixel, useful info on sprite size
	//TODO : size is not SGDK compliant, you need to use size>>8
};
typedef struct genresSprites genresSprites_t;

//ANIMATION
struct animSpriteInfo{
	u16	idx;
	u8	x,y; // upon frame upper left
};

struct animFrame {
	u16	nbSprites;
	struct 	animSpriteInfo	*sprites;

	u8	timer;
	u8	nextFrameIdx;
};

struct genresAnimation {
	u16	*pal;
	u16	width;
	u16	height;

	//frame data
	u16	nbFrames;
	struct	animFrame		**frames;

	//sprite data
	u8 	sprite_width;
	u8 	sprite_height;
	u32 nbTiles;
	u16	*sprite_data;
};
typedef struct genresAnimation genresAnim_t;

//PAL
//typedef u16	genresPal[16];
struct genresPal {
	u16 color[16];
};
typedef struct genresPal genresPal_t;

//MAP
struct genresMap{
	//map size
	u16	width;
	u16	height;
	
	//pal
	u16	*pal;

	//tiles	
	u16	nbTiles; //number of tiles used
	u16	compSize; //0 if not compressed
	u32	*tiles; //pointer to tiles data
	
	//map
	u16	nbLayers; //1 - not used yet
	u16	*map; //pointer to map data
};
typedef struct genresMap genresMap_t;


//CONTROLS
struct genresControlKey{
	u16	ID;
	u16	keys[1]; //array of keys, finished by zero
};
typedef struct genresControlKey genresControlKey_t;

struct genresControl{
	u16	nbControls;
	genresControlKey_t	**keys; //pointer to map data
};
typedef struct genresControl genresControl_t;

#endif /* GENRES_H_ */
